/*	Maze Generator

	Anthony Kozar
	April 10, 2001: original code for school project
	April 16, 2004: modified to generate random mazes
	May 29, 2004: modified for use with LodeRunner 2 level creator
 */

#include	<iostream>
#include	<fstream>
#include	<string>

#include	"mazegen.h"

maze_type<simple_block>* MakeOneMaze()
{
	int	rows, columns;
	//coord	start, finish;
	maze_type<simple_block>* maze = NULL;

	cout	<< "Number of rows? ";
	cin	>> rows;
	cout	<< "Number of columns? ";
	cin	>> columns;

	maze = GenerateMaze(rows,columns);
	
	//read_maze(maze);						// read in the wall coordinates from file
	cout	<< endl;
	maze->print_maze(cout);					// print the maze to standard out
	cout	<< endl;
	
	return maze;
	
/*	// read in the start and finish coordinates
	cout	<< "Enter the X and Y coordinates for the Start position: ";
	cin	>> start.first >> start.second;
	cout	<< "Enter the X and Y coordinates for the Finish position: ";
	cin	>> finish.first >> finish.second;
	cout	<< endl;
	
	// look for a path from start to finish and print it out if found
	maze.find_path(start, finish);
*/	
}

maze_type<simple_block>* GenerateMaze( int rows, int columns )
{
	maze_type<simple_block>* maze = NULL;
	maze = new maze_type<simple_block>(columns, rows);
	if	(! maze->make_maze())	{
		cerr	<< "make_maze() failed!\n";
		exit(1);
	}
	return maze;
}

void	read_maze( maze_type<simple_block>& theMaze )
{
	ifstream	fin;
	coord		wall;
	int		wall_count;
	string	filename;
	
	// open "a:mazein.txt" or prompt for a filename if it does not exist
	fin.open("a:mazein.txt");
	while	( fin.fail() )	{
		cout	<< "Unable to open the input file. Please enter a filename to open: ";
		cin	>> filename;
		fin.clear();
		fin.open(filename.c_str());
	}
	
	// read in sets of coordinates for walls one at a time, checking and then placing them
	wall_count = 0;
	cout << "Reading solid coordinates from file." << endl << endl;
	while	( fin >> wall.first )	{
		fin >> wall.second;
		if	( wall.first < 1 || wall.first > 20 || wall.second < 1 || wall.second > 20 )	{
			cout << "There was an error reading in the file." << endl;
			exit(-1);
		}
		
		theMaze.place_wall( wall );
		wall_count++;
	}
	
	cout	<< wall_count << " solid blocks placed in maze." << endl << endl;
	fin.close();

	return;
}	
	
		